=== webots/src/controller/Makefile ===
# Copyright 1996-2023 Cyberbotics Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include ../../resources/Makefile.os.include

.PHONY: release debug profile

release debug profile clean:
	@echo "#"
	@echo "# C controller library ("$@")"
	@echo "#"
	@+make -s -C c $@
	@echo "#"
	@echo "# C++ controller library ("$@")"
	@echo "#"
	@+make -s -C cpp $@
	@echo "#"
	@echo "# Java controller library ("$@")"
	@echo "#"
	@+make -s -C java $@
	@echo "# Matlab controller library ("$@")"
	@echo "#"
	@+make -s -C matlab $@
