=== debian/control ===
Source: ros-foxy-webots-ros2-driver
Section: misc
Priority: optional
Maintainer: Cyberbotics <support@cyberbotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-python, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-geometry-msgs, ros-foxy-pluginlib, ros-foxy-python-cmake-module, ros-foxy-rclcpp, ros-foxy-rclpy, ros-foxy-ros-environment, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-tinyxml2-vendor, ros-foxy-vision-msgs, ros-foxy-webots-ros2-importer, ros-foxy-webots-ros2-msgs, ros-foxy-ros-workspace
Homepage: http://wiki.ros.org/webots_ros2
Standards-Version: 3.9.2

Package: ros-foxy-webots-ros2-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-geometry-msgs, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rclpy, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-tinyxml2-vendor, ros-foxy-vision-msgs, ros-foxy-webots-ros2-importer, ros-foxy-webots-ros2-msgs, ros-foxy-ros-workspace
Description: Implementation of the Webots - ROS 2 interface
